dofile("scripts/base/util/base-lua-functions.lua")
dofile("scripts/base/util/state.lua")
dofile("scripts/base/util/kolproxy-core-functions.lua")
dofile("scripts/base/util/script-functions.lua")
dofile("scripts/base/util/charpane.lua")
dofile("scripts/base/util/api.lua")


function get_plural(v, singular, plural)
	if v == 1 then
		return singular
	else
		return plural
	end
end


-- TODO: redo this code
function setup_variables()
	if path == "/charpane.php" then
		familiar_picture, familiar_weight = text:match([[<a target=mainpane href="familiar.php" class="familiarpick"><img src="http://images.kingdomofloathing.com/itemimages/([^\"]-).gif" width=30 height=30 border=0></a><br>([0-9]+) lb]])
		if not familiar_picture then
			familiar_picture, familiar_weight = text:match([[<a target=mainpane href="familiar.php" class="familiarpick"><img src="http://images.kingdomofloathing.com/itemimages/([^\"]-).gif" width=30 height=30 border=0>.- <b>([0-9]+)</b> pound ]]) -- TODO-future: redo without .-?
		end
		familiar_weight = tonumber(familiar_weight)
		if text:match([[<td align=right>Meat:.-</table>]]) then
			compact_charpane = true
		elseif text:match([[src="http://images.kingdomofloathing.com/itemimages/hourglass.gif".-</table>]]) then
			normal_charpane = true
		end
	elseif path == "/kolproxy-quick-charpane-normal" or path == "/kolproxy-quick-charpane-compact" then
		using_kolproxy_quick_charpane = true
		kolproxy_custom_charpane_mode = "normal"
		if path == "/kolproxy-quick-charpane-compact" then
			kolproxy_custom_charpane_mode = "compact"
		end
		path = "/charpane.php" -- TODO: hack!
-- 		print " / # / get_status_info() hacks for familiar pic and weight"
		local s = get_status_info()
		familiar_picture = s.familiarpic
		familiar_weight = s.famlevel
		compact_charpane = true
	end

	for x in text:gmatch("var onturn = ([0-9]+);") do
		combat_round = tonumber(x)
	end

	monster_name = text:match("<span id='monname'>(.-)</span>")

	if path == "/fight.php" then
		local z = get_fight_state("zone")
		if z ~= "" then
			adventure_zone = tonumber(z)
		end
	end

	if monster_name and query:match("ireallymeanit") then -- this happens not to get set when using copied monsters, but redo better?
		new_fight_started = true
	end

-- 	print("monster stuff", monster_name, new_fight_started, query, path, requestpath, requestquery)

	adventure_title = text:match([[<tr><td style="color: white;" align=center bgcolor=blue.-><b>([^<]*)</b></td></tr>]])
	choice_adventure_number = tonumber(text:match([[<input type=hidden name=whichchoice value=([0-9]+)>]]))
	adventure_result = text:match([[<td style="color: white;" align=center bgcolor=blue.-><b>Adventure Results:</b></td></tr><tr><td style="padding: 5px; border: 1px solid blue;"><center><table><tr><td><center><b>([^<]*)</b>]])

	fight_is_over = nil
	if path == "/fight.php" then
		if text:contains("state['fightover'] = true;") then -- TODO: HACK! this only works with combat bar enabled!!
			fight_is_over = true
		else
			fight_is_over = false
		end
	end
end











-- -- Should be in other files -- --

function faxbot_monsterlist()
	local popular_names = {
		"Bad ASCII Art",
		"Blooper",
		"dirty thieving brigand",
		"ghost",
		"Knob Goblin Elite Guard Captain",
		"lobsterfrogman",
		"rampaging adding machine",
		"sleepy mariachi",
	}
	local category_order = {
		"Most Popular",
		"Sorceress's Quest",
		"Misc Ascension",
		"Misc Aftercore",
		"Bounty Targets",
		"Crimbo 2009",
		"Crimbo 2010",
		"Rock Event",
		"Bigg's Dig",
		"The Shivering Timbers",
		"Skeleton Invasion",
		"Talk Like A Pirate Day",
		"Featured Butts",
	}
	local category_contents = {}
	for x in table.values(category_order) do
		category_contents[x] = {}
	end
	local count_names = {}
	for _, x in ipairs(get_faxbot_monsterlist()) do
		count_names[x.name] = (count_names[x.name] or 0) + 1
	end
	for _, x in ipairs(get_faxbot_monsterlist()) do
		if not category_contents[x.category] then
			category_contents[x.category] = {}
			table.insert(category_order, x.category)
		end
		local newx = nil
		if count_names[x.name] == 1 then
			newx = { name = x.name, command = x.command }
		else
			newx = { name = x.description, command = x.command }
		end
		table.insert(category_contents[x.category], newx)
		for z in table.values(popular_names) do
			if z == x.name then
				table.insert(category_contents["Most Popular"], newx)
			end
		end
	end
	for x in table.values(category_contents) do
		table.sort(x, function(a, b)
			return a.name:lower() < b.name:lower()
		end)
	end
	return category_contents, category_order
end


dod_potion_types = {
	"bubbly potion",
	"cloudy potion",
	"dark potion",
	"effervescent potion",
	"fizzy potion",
	"milky potion",
	"murky potion",
	"smoky potion",
	"swirly potion",
}

dod_potion_effects = {
	"acuity",
	"blessing",
	"booze",
	"confusion",
	"detection",
	"healing",
	"sleep",
	"strength",
	"teleportation",
}

function get_dod_potion_status()
	local tbl = get_ascension_state("zone.dod.potions")
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
	unknown_potions = {}
	for pot in table.values(dod_potion_types) do
		if not tbl[pot] then
			table.insert(unknown_potions, pot)
		end
	end

	found = {}
	for pot, eff in pairs(tbl) do
		found[eff] = pot
	end

	unknown_effects = {}
	for eff in table.values(dod_potion_effects) do
		if not found[eff] then
			table.insert(unknown_effects, eff)
		end
	end

	if table.maxn(unknown_effects) == 1 and table.maxn(unknown_potions) == 1 then -- only one missing effect and one missing potion
		tbl[unknown_potions[1]] = unknown_effects[1]
		return tbl, {}
	else
		return tbl, unknown_potions
	end
end










local function get_wine_cellar_permutations_and_quadrants(tbl)
	local quadrants = {
		{ ["dusty bottle of Marsala"] = true, ["dusty bottle of Merlot"] = true, ["dusty bottle of Muscat"] = true }, -- 1
		{ ["dusty bottle of Marsala"] = true, ["dusty bottle of Pinot Noir"] = true, ["dusty bottle of Zinfandel"] = true }, -- 2
		{ ["dusty bottle of Merlot"] = true, ["dusty bottle of Pinot Noir"] = true, ["dusty bottle of Port"] = true }, -- 3
		{ ["dusty bottle of Muscat"] = true, ["dusty bottle of Port"] = true, ["dusty bottle of Zinfandel"] = true }, -- 4
	}

	local permutations = {
		{ [178] = 1, [179] = 2, [180] = 3, [181] = 4 }, -- 1
		{ [178] = 1, [179] = 2, [180] = 4, [181] = 3 }, -- 2
		{ [178] = 1, [179] = 3, [180] = 2, [181] = 4 }, -- 3
		{ [178] = 1, [179] = 3, [180] = 4, [181] = 2 }, -- 4
		{ [178] = 1, [179] = 4, [180] = 2, [181] = 3 }, -- 5
		{ [178] = 1, [179] = 4, [180] = 3, [181] = 2 }, -- 6
		{ [178] = 2, [179] = 1, [180] = 3, [181] = 4 }, -- 7
		{ [178] = 2, [179] = 1, [180] = 4, [181] = 3 }, -- 8
		{ [178] = 2, [179] = 3, [180] = 1, [181] = 4 }, -- 9
		{ [178] = 2, [179] = 3, [180] = 4, [181] = 1 }, -- 10
		{ [178] = 2, [179] = 4, [180] = 1, [181] = 3 }, -- 11
		{ [178] = 2, [179] = 4, [180] = 3, [181] = 1 }, -- 12
		{ [178] = 3, [179] = 1, [180] = 2, [181] = 4 }, -- 13
		{ [178] = 3, [179] = 1, [180] = 4, [181] = 2 }, -- 14
		{ [178] = 3, [179] = 2, [180] = 1, [181] = 4 }, -- 15
		{ [178] = 3, [179] = 2, [180] = 4, [181] = 1 }, -- 16
		{ [178] = 3, [179] = 4, [180] = 1, [181] = 2 }, -- 17
		{ [178] = 3, [179] = 4, [180] = 2, [181] = 1 }, -- 18
		{ [178] = 4, [179] = 1, [180] = 2, [181] = 3 }, -- 19
		{ [178] = 4, [179] = 1, [180] = 3, [181] = 2 }, -- 20
		{ [178] = 4, [179] = 2, [180] = 1, [181] = 3 }, -- 21
		{ [178] = 4, [179] = 2, [180] = 3, [181] = 1 }, -- 22
		{ [178] = 4, [179] = 3, [180] = 1, [181] = 2 }, -- 23
		{ [178] = 4, [179] = 3, [180] = 2, [181] = 1 }, -- 24
	}

	for z, ztbl in pairs(tbl) do -- remove invalid permutations
		for name, _ in pairs(ztbl) do
			for i = 1, 24 do
				if permutations[i] then
					local qid = permutations[i][z]
					if not quadrants[qid][name] then
						permutations[i] = nil
					end
				end
			end
		end
	end
	return permutations, quadrants
end

function get_wine_cellar_data(known_tbl)
	local permutations, quadrants = get_wine_cellar_permutations_and_quadrants(known_tbl)

	local wines = {}
	local valid_permutations = 0

	for ptbl in table.values(permutations) do
		for z, qid in pairs(ptbl) do
			for name, _ in pairs(quadrants[qid]) do
				if not wines[z] then wines[z] = {} end
				if not wines[z][name] then wines[z][name] = 0 end
				wines[z][name] = wines[z][name] + 1
			end
		end
		valid_permutations = valid_permutations + 1
	end
	return wines, valid_permutations
end
