add_printer("/game.php", function()
	if character["use custom kolproxy charpane"] ~= "yes" then return end
	text = text:gsub([[(<frameset id=mainset cols=)"120,%*"(>)]], [[%1"200, *"%2]])
end)

local function kolproxy_custom_charpane_mode()
	if tonumber(api_flag_config().compactchar) == 1 then
		return "compact"
	else
		return "normal"
	end
end

-- TODO: merge common code

-- TODO: custom buff coloring, sort order?

local function get_familiar_grid(columns)
	fams_per_line = columns

	local familiarfaves = session["favorite familiars"]
	if not familiarfaves then
		print("getting familiar favorites")
		local famid = familiarid()

		local was_locked = false
		local fampt = get_page("/familiar.php")
		if fampt:contains("title='This Familiar Equipment is Locked'") then
			was_locked = true
		end
		post_page("/familiar.php", { action = "putback", ajax = 1 })
		local cppt = get_page("/charpane.php")
		get_page("/familiar.php", { action = "newfam", ajax = 1, newfam = famid })
		if was_locked then
			get_page("/familiar.php", { action = "lockequip", ajax = 1, pwd = cppt:match([[var pwdhash = "([0-9a-f]+)";]]) })
		end
		familiarfaves = cppt:match("var FAMILIARFAVES = %[.-%];") or "{Fake no faves text}"
		session["favorite familiars"] = familiarfaves
	end
	return make_familiar_grid(familiarfaves:match("var FAMILIARFAVES = %[(.-)%];"), session.pwd)
end

local function pathdesc()
	local prefix = ""
	if ascensionstatus() == "Hardcore" then
		prefix = "HC"
	elseif ascensionstatus() == "Softcore" then
		prefix = "SC"
	end
	if moonsign() == "Bad Moon" then
		return "BM"
	elseif ascensionpath() == "Teetotaler" then
		return prefix .. "T"
	elseif ascensionpath() == "Boozetefarian" then
		return prefix .. "B"
	elseif ascensionpath() == "Oxygenarian" then
		return prefix .. "O"
	elseif ascensionpath() == nil or ascensionpath() == "" or ascensionpath() == "None" then
		-- TODO: add the stupid CDM "5" and "6" path stuff
		if prefix ~= "" then
			return prefix .. "NP"
		else
			return ""
		end
	else
		return prefix .. ":" .. tostring(ascensionpath())
	end
end

local function classdesc()
	local descs = {
		compact = { "SC", "TT", "PM", "S", "DB", "AT" },
		normal = { "Seal Clubber", "Turtle Tamer", "Pastamancer", "Sauceror", "Disco Bandit", "Accordion Thief" },
	}
	return descs[kolproxy_custom_charpane_mode()][classid()]
end

local function classpathdesc()
	local p = pathdesc()
	if p ~= "" then
		return string.format("%s %s", p, classdesc())
	else
		return classdesc()
	end
end

local function format_integer(i)
	if i >= 1000 then
		local upper = math.floor(i / 1000)
		return format_integer(upper) .. "," .. string.format("%03d", i - upper * 1000)
	else
		return i
	end
end

local function format_hpmp(c, m)
	if c == m then
		return string.format([[<span style="color: green">%s</span>]], format_integer(c))
	elseif c < m * 0.25 then
		return string.format([[<span style="color: red">%s / %s</span>]], format_integer(c), format_integer(m))
	else
		return string.format([[%s / %s]], format_integer(c), format_integer(m))
	end
end

local function get_srdata(SRtitle)
	local SRnow, good_numbers, all_numbers, SRmin, SRmax, is_first_semi, lastsemi = get_semirare_info(turnsthisrun())
	local value = ""
	local color = "black"
	if SRnow then
		color = "green"
	end
	if table.maxn(good_numbers) > 0 then
		value = good_numbers[1]
		for x, _ in pairs(good_numbers) do
			if x > 1 then
				value = value .. "+"
			end
		end
	else
		value = "?"
	end

	if (not lastsemi) and (not is_first_semi) then
		lastsemi = "?"
	end
	
	local tooltip = ""
	if table.maxn(all_numbers) > 0 then
		tooltip = tooltip .. "Fortune cookie numbers: " .. table.concat(all_numbers, ", ")
	else
		tooltip = tooltip .. "Fortune cookie numbers: ?"
	end

	if SRmin and SRmax and SRmax >= 0 then
		if value == "?" then
			value = SRmin .. " to " .. SRmax
		end
		tooltip = tooltip .. ", range = " .. SRmin .. " to " .. SRmax
	else
		if value ~= "?" then
			value = value .. "?"
		end
		tooltip = tooltip .. ", range = ?"
	end

	if lastsemi then
		tooltip = tooltip .. ", last semirare = " .. lastsemi
	end
	local bgcolor = "white"
	local showlast = nil
	if SRnow then
		bgcolor = "lightgreen"
	end

	local srdata = string.format([[%s: <span style="color: %s" title="%s"><b>%s</b></span>]], SRtitle, color, tooltip, value)
	if SRnow and lastsemi then
		srdata = srdata .. string.format([[<br>Last SR: %s]], lastsemi)
	end

	return bgcolor, srdata
end

add_interceptor("/charpane.php", function()
	if character["use custom kolproxy charpane"] ~= "yes" then return end
	if not pcall(turnsthisrun) then return end -- in afterlife
	if kolproxy_custom_charpane_mode() ~= "compact" then return end
	local extra_js, fams = get_familiar_grid(4)
-- 	print(table_to_str(fams))

-- name
-- level / progress
-- mus / mys / mox
-- full / drunk / spleen
-- hp / maxhp
-- mp / maxmp
-- meat
-- advs / turnsplayed
-- mcd ??
-- zone
-- semirare
-- familiar, weight, bonus
-- buffs

	local bgcolor, srdata = get_srdata("SR")

	local lines = {}
	table.insert(lines, string.format([[<a class="nounder" target="mainpane" href="charsheet.php"><b>%s</b></a> <span class="tiny">(%s)</span>]], playername(), classpathdesc()))
	table.insert(lines, string.format([[Level: <b>%s</b> <span class="tiny">(%s to go)</span>]], round_down(level() + level_progress(), 1), format_integer(substats_for_level(level() + 1) - rawmainstat())))
-- 	table.insert(lines, string.format([[Mainstat: <b><span style="color: blue; font-weight: bold;">%s</span> (%s)</b>]], format_integer(buffedmainstat()), format_integer(basemainstat())))
	table.insert(lines, string.format([[Buffed: <b><span style="color: blue; font-weight: bold;">%s</span></b> / <b><span style="color: blue; font-weight: bold;">%s</span></b> / <b><span style="color: blue; font-weight: bold;">%s</span></b>]], format_integer(buffedmuscle()), format_integer(buffedmysticality()), format_integer(buffedmoxie())))
	table.insert(lines, string.format([[Base: <b>%s</b> / <b>%s</b> / <b>%s</b>]], format_integer(basemuscle()), format_integer(basemysticality()), format_integer(basemoxie())))
	table.insert(lines, string.format([[Organs: <b>%s</b> / <b>%s</b> / <b>%s</b>]], fullness(), drunkenness(), spleen()))
	table.insert(lines, "")
	table.insert(lines, string.format([[HP: <b>%s</b>]], format_hpmp(hp(), maxhp())))
	table.insert(lines, string.format([[MP: <b>%s</b>]], format_hpmp(mp(), maxmp())))
	table.insert(lines, string.format([[Meat: <b>%s</b>]], format_integer(meat())))
	table.insert(lines, string.format([[Turns: <b>%s</b> <span class="tiny">(%s played)</span>]], advs(), turnsthisrun()))
	table.insert(lines, string.format([[<a href="%s" target="mainpane">Zone</a>: <b><a href="%s" target="mainpane">%s</a></b>]], lastadventuredata().container or "", lastadventuredata().link, lastadventuredata().name))
	table.insert(lines, "<!-- kolproxy charpane text area -->")

	table.insert(lines, srdata)

	local next_bee_turn = ascension["bee turn"]
	local bee_value = nil
	if next_bee_turn then
		local turnmin = next_bee_turn - turnsthisrun()
		local turnmax = next_bee_turn + 5 - turnsthisrun()
		if turnmax >= 0 then
			if turnmin < 0 then turnmin = 0 end
			bee_value = turnmin .. "-" .. turnmax
		end
	else
-- 		bee_value = "?"
	end
	if bee_value then
		table.insert(lines, string.format([[Bee: %s]], bee_value))
	end

	for _, x in ipairs(ascension["turn counters"] or {}) do
		local turns = x.turn + x.length - turnsthisrun()
		if turns >= 0 then
			if turnsleft == 0 then
				table.insert(lines, string.format([[%s: <b style="color: green">%s</b>]], x.name, turns))
			else
				table.insert(lines, string.format([[%s: <b>%s</b>]], x.name, turns))
			end
		end
	end

	table.insert(lines, "")

	local function get_equip_line(tbl)
		local equipstr = ""
		for _, x in ipairs(tbl) do
			local pic = "blank"
			if equipment()[x] then
				pic = itemid_api_data(equipment()[x]).picture
			end
			equipstr = equipstr .. string.format([[<img src="http://images.kingdomofloathing.com/itemimages/%s.gif" width="30" height="30" style="border: solid thin lightgray;">]], pic)
		end
		return equipstr
	end
	table.insert(lines, string.format("<center>%s<br>%s</center>", get_equip_line { "hat", "shirt", "weapon", "offhand", "pants" }, get_equip_line { "acc1", "acc2", "acc3", "familiarequip" }))

	if familiarid() ~= 0 then
		fams[familiarpicture()] = { link = string.format([[<a href="familiar.php" target="mainpane"><img src="http://images.kingdomofloathing.com/itemimages/%s.gif" width="30" height="30" style="border: solid thin black"></a>]], familiarpicture()) }

		local famnames = {}
		for a, b in pairs(fams) do
			table.insert(famnames, a)
		end
		table.sort(famnames)
		local famchoosertext = ""
		local spacetimer = 1
		for _, b in ipairs(famnames) do
			famchoosertext = famchoosertext .. fams[b].link
			if spacetimer >= fams_per_line then
				famchoosertext = famchoosertext .. "<br>"
				spacetimer = 1
			else
				spacetimer = spacetimer + 1
			end
		end
		table.insert(lines, "<center>" .. famchoosertext .. "</center>")
		table.insert(lines, string.format([[<center>%s lbs.<!-- kolproxy charpane familiar text area --></center>]], buffedfamiliarweight()))
	else
		table.insert(lines, [[<center><a href="familiar.php" target="mainpane">No familiar</a></center>]])
	end

	local buff_colors = {
		["On the Trail"] = "purple",
		["Everything Looks Red"] = "red",
		["Everything Looks Blue"] = "blue",
		["Everything Looks Yellow"] = "goldenrod",
	}
	local bufflines = {}
	local sorting = {}
	for descid, x in pairs(status().effects) do
		table.insert(sorting, { title = x[1], duration = tonumber(x[2]), imgname = x[3], descid = descid }) -- HACK: tonumber is a workaround for CDM effects being strings or numbers randomly
	end
	table.sort(sorting, function (a, b)
		if a.duration ~= b.duration then return a.duration < b.duration end
		if a.title ~= b.title then return a.title < b.title end
		if a.imgname ~= b.imgname then return a.imgname < b.imgname end
		return a.descid < b.descid
	end)
	local curbuffline = nil
	for _, x in ipairs(sorting) do
		local styleinfo = ""
		local imgstyleinfo = ""
		if buff_colors[x.title] then
			styleinfo = string.format([[ style="color: %s"]], buff_colors[x.title])
			imgstyleinfo = string.format([[ style="background-color: %s"]], buff_colors[x.title])
		end
		local str = string.format([[<td title="%s"%s><img src="http://images.kingdomofloathing.com/itemimages/%s.gif" style="width: 25px; height: 25px; cursor: pointer;" onClick='popup_effect("%s");''></td><td title="%s"%s>(%s)</td>]], x.title, imgstyleinfo, x.imgname, x.descid, x.title, styleinfo, x.duration)
		if not curbuffline then
			curbuffline = str
		else
			table.insert(bufflines, string.format([[<tr>%s<td>&nbsp;</td>%s</tr>]], curbuffline, str))
			curbuffline = nil
		end
	end
	if curbuffline then
		table.insert(bufflines, string.format([[<tr>%s<td></td><td></td></tr>]], curbuffline))
	end
	table.insert(lines, [[<center><table>]] .. table.concat(bufflines) .. [[</table></center>]])

	if ascensionstatus() == "Aftercore" then
		local href = "http://kol.obeliks.de" .. raw_make_href("/buffbot/buff", {
			{ key = "style", value = "kol" },
-- 			{ key = "style", value = "kolproxy" },
			{ key = "target", value = playername() },
		})
		table.insert(lines, [[<center><a href="]]..href..[[" target="mainpane" style="color: green">{Get buffs}</a></center>]])
	end

	local text = [[
<html>
<head>
	<style type="text/css">
body {
	font-family: Arial, Helvetica, sans-serif;
	background-color: ]] .. bgcolor .. [[;
	color: black;
	font-size: 0.8em;
}
td {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 0.8em;
}
a:link { color: black; }
a:visited {	color: black; }
a:active { color: black; }
.nounder { text-decoration: none; }
.tiny { font-size: 0.9em; }
	</style>
	<script type="text/javascript">
		function popup_effect(descid) {
			var w = window.open("desc_effect.php?whicheffect=" + descid, "effect", "height=200,width=300")
			if (w.focus) w.focus()
		}
	</script>
	<script type="text/javascript" src="http://images.kingdomofloathing.com/scripts/jquery-1.3.1.min.js"></script>

]] .. extra_js .. [[

</head>
<body>
]] .. table.concat(lines, "<br>") .. [[
</body>
</html>]]
	return text, "/kolproxy-quick-charpane-compact"
end)

-- game.php
-- <frameset id=mainset cols="120,*">
-- <frameset id=mainset cols="200,*">

-- TODO: resize frameset, allow custom frame layouts?







add_interceptor("/charpane.php", function()
	if character["use custom kolproxy charpane"] ~= "yes" then return end
	if not pcall(turnsthisrun) then return end -- in afterlife
	if kolproxy_custom_charpane_mode() ~= "normal" then return end

	local extra_js, fams = get_familiar_grid(4)

	local bgcolor, srdata = get_srdata("Semirare")

	local lines = {}
local moo = [[

]]

	local _, have, need = level_progress()
	table.insert(lines, [[<center>]])
	table.insert(lines, string.format([[<a class=nounder target=mainpane href="charsheet.php"><b>%s</b></a><br>Level %s<br>%s]], playername(), level(), classdesc()))
	table.insert(lines, string.format([[<table title='%s / %s' cellpadding=0 cellspacing=0 style='border: 1px solid #5A5A5A'><tr><td height=5 width=20 bgcolor=#5A5A5A></td><td width=80 bgcolor=white></td></tr></table>]], format_integer(have), format_integer(need)))
	table.insert(lines, [[</center><br>]])
	table.insert(lines, [[<table align=center>]])
	local function add_stat_line(statname, buffed, base, have_substat, need_substat)
		local filled_width = math.floor((have_substat / need_substat) * 50)
		local remaining_width = 50 - math.floor((have_substat / need_substat) * 50)
		table.insert(lines, string.format([[<tr><td align=right>%s</td><td align=left><b><font color=blue>%s</font>&nbsp;(%s)</b><table title='%s / %s' cellpadding=0 cellspacing=0 style='border: 1px solid #5A5A5A'><tr><td height=3 width=%s bgcolor=#5A5A5A></td><td width=%s bgcolor=white></td></tr></table></td></tr>]], statname, format_integer(buffed), format_integer(base), format_integer(have_substat), format_integer(need_substat), filled_width, remaining_width))
	end
	add_stat_line("Muscle:", buffedmuscle(), basemuscle(), 10, 100)
	add_stat_line("Mysticality:", buffedmysticality(), basemysticality(), 20, 100)
	add_stat_line("Moxie:", buffedmoxie(), basemoxie(), 30, 100)
	local function add_organ_line(organdescs, amount)
		local desc = random_choice(organdescs)
		table.insert(lines, string.format([[<tr><td align=right>%s</td><td><b>%s</b></td></tr>]], desc, format_integer(amount)))
	end
	add_organ_line({ "Engorgement:", "Gluttony:", "Satiation:" }, fullness())
	add_organ_line({ "Inebriety:", "Temulency:", "Tipsiness:" }, drunkenness())
	add_organ_line({ "Melancholy:", "Moroseness:", "Spleen:" }, spleen())
	table.insert(lines, [[</table>]])

	table.insert(lines, [[<table cellpadding=3 align=center>]])
	table.insert(lines, string.format([[<tr><td align=center><img src="http://images.kingdomofloathing.com/itemimages/hp.gif" class=hand title="Hit Points" alt="Hit Points"><br><span class=black>%s&nbsp;/&nbsp;%s</span></td>]], format_integer(hp()), format_integer(maxhp())))
	local mpname = ({ "Muscularity Points", "Muscularity Points", "Mana Points", "Mana Points", "Mojo Points", "Mojo Points" })[classid()]
	table.insert(lines, string.format([[<td align=center><img src="http://images.kingdomofloathing.com/itemimages/mp.gif" class=hand title="%s" alt="%s"><br><span class=black>%s&nbsp;/&nbsp;%s</span></td></tr>]], mpname, mpname, format_integer(mp()), format_integer(maxmp())))
	table.insert(lines, string.format([[<tr><td align=center><img src="http://images.kingdomofloathing.com/itemimages/meat.gif" class=hand title="Meat" alt="Meat"><br><span class=black>%s</span></td>]], format_integer(meat())))
	table.insert(lines, string.format([[<td align=center><img src="http://images.kingdomofloathing.com/itemimages/hourglass.gif" class=hand title="Adventures Remaining" alt="Adventures Remaining"><br><span class=black>%s</span></td></tr>]], format_integer(advs())))
	table.insert(lines, [[</table>]])

-- 	table.insert(lines, string.format([[<a href="%s" target="mainpane">Zone</a>: <b><a href="%s" target="mainpane">%s</a></b>]], lastadventuredata().container or "", lastadventuredata().link, lastadventuredata().name))
	table.insert(lines, [[<center><font size="2">]]..srdata..[[</font></center>]])
	table.insert(lines, string.format([[<center><font size="2">Turns played: <b>%s</b></font></center>]], turnsthisrun()))
	table.insert(lines, "<!-- kolproxy charpane text area -->")
	table.insert(lines, [[<br>]])
	table.insert(lines, string.format([[<center><font size=2><b><a class=nounder href="%s" target=mainpane>Last Adventure:</a></b></font><br><font size=2><a target=mainpane href="%s">%s</a><br></font></center>]], lastadventuredata().container or "", lastadventuredata().link, lastadventuredata().name))
	table.insert(lines, [[<br>]])

	-- TODO: make bee counter generic and auto-insert

	for _, x in ipairs(ascension["turn counters"] or {}) do
		local turns = x.turn + x.length - turnsthisrun()
		if turns >= 0 then
			if turnsleft == 0 then
				table.insert(lines, string.format([[%s: <b style="color: green">%s</b>]], x.name, turns))
			else
				table.insert(lines, string.format([[%s: <b>%s</b>]], x.name, turns))
			end
		end
	end

	table.insert(lines, "")

	if familiarid() ~= 0 then
		fams[familiarpicture()] = { link = string.format([[<a href="familiar.php" target="mainpane"><img src="http://images.kingdomofloathing.com/itemimages/%s.gif" width="30" height="30" style="border: solid thin black"></a>]], familiarpicture()) }

		local famnames = {}
		for a, b in pairs(fams) do
			table.insert(famnames, a)
		end
		table.sort(famnames)
		local famchoosertext = ""
		local spacetimer = 1
		for _, b in ipairs(famnames) do
			famchoosertext = famchoosertext .. fams[b].link
			if spacetimer >= fams_per_line then
				famchoosertext = famchoosertext .. "<br>"
				spacetimer = 1
			else
				spacetimer = spacetimer + 1
			end
		end
		table.insert(lines, "<center>" .. famchoosertext .. "</center>")
		table.insert(lines, string.format([[<center><font size=2>%s lbs.<!-- kolproxy charpane familiar text area --></font></center>]], buffedfamiliarweight()))
	else
		table.insert(lines, [[<center><a href="familiar.php" target="mainpane">No familiar</a></center>]])
	end

	local buff_colors = {
		["On the Trail"] = "purple",
		["Everything Looks Red"] = "red",
		["Everything Looks Blue"] = "blue",
		["Everything Looks Yellow"] = "goldenrod",
	}
	local bufflines = {}
	local sorting = {}
	for descid, x in pairs(status().effects) do
		table.insert(sorting, { title = x[1], duration = tonumber(x[2]), imgname = x[3], descid = descid }) -- HACK: tonumber is a workaround for CDM effects being strings or numbers randomly
	end
	table.sort(sorting, function (a, b)
		if a.duration ~= b.duration then return a.duration < b.duration end
		if a.title ~= b.title then return a.title < b.title end
		if a.imgname ~= b.imgname then return a.imgname < b.imgname end
		return a.descid < b.descid
	end)
	local curbuffline = nil
	for _, x in ipairs(sorting) do
		local styleinfo = ""
		local imgstyleinfo = ""
		if buff_colors[x.title] then
			styleinfo = string.format([[ style="color: %s"]], buff_colors[x.title])
			imgstyleinfo = string.format([[ style="background-color: %s"]], buff_colors[x.title])
		end
		local str = string.format([[<td title="%s"%s><img src="http://images.kingdomofloathing.com/itemimages/%s.gif" style="width: 25px; height: 25px; cursor: pointer;" onClick='popup_effect("%s");''></td><td title="%s"%s><font size=2>(%s)</font></td>]], x.title, imgstyleinfo, x.imgname, x.descid, x.title, styleinfo, x.duration)
		if not curbuffline then
			curbuffline = str
		else
			table.insert(bufflines, string.format([[<tr>%s<td>&nbsp;</td>%s</tr>]], curbuffline, str))
			curbuffline = nil
		end
	end
	if curbuffline then
		table.insert(bufflines, string.format([[<tr>%s<td></td><td></td></tr>]], curbuffline))
	end
	table.insert(lines, [[<br>]])
	table.insert(lines, [[<center><table>]] .. table.concat(bufflines) .. [[</table></center>]])

	if ascensionstatus() == "Aftercore" then
		local href = "http://kol.obeliks.de" .. raw_make_href("/buffbot/buff", {
			{ key = "style", value = "kol" },
-- 			{ key = "style", value = "kolproxy" },
			{ key = "target", value = playername() },
		})
		table.insert(lines, [[<center><a href="]]..href..[[" target="mainpane" style="color: green">{Get buffs}</a></center>]])
	end

	local text = [[
<html>
<head>
	<style type="text/css">
body {
	font-family: Arial, Helvetica, sans-serif;
	background-color: ]] .. bgcolor .. [[;
	color: black;
}
td {
	font-family: Arial, Helvetica, sans-serif;
}
a:link { color: black; }
a:visited {	color: black; }
a:active { color: black; }
.nounder { text-decoration: none; }
.tiny { font-size: 0.9em; }
.black {
   font-weight: bold;
   color: black;
   font-size: smaller;
}
	</style>
	<script type="text/javascript">
		function popup_effect(descid) {
			var w = window.open("desc_effect.php?whicheffect=" + descid, "effect", "height=200,width=300")
			if (w.focus) w.focus()
		}
	</script>
	<script type="text/javascript" src="http://images.kingdomofloathing.com/scripts/jquery-1.3.1.min.js"></script>
]] .. extra_js .. [[

</head>
<body>
]] .. table.concat(lines) .. [[
</body>
</html>]]
	return text, "/kolproxy-quick-charpane-normal"
end)
