-- io = nil
os = nil
-- debug = nil
require = nil
module = nil
package = nil

-- TODO: Move to kolproxy core(?)
raw_input_params = params
params = nil

function wrapped_function()

if can_read_state() ~= "yes" then
	return text
end

local processors = {}

local function add_processor_raw(scriptname, file, func)
	if not processors[file] then processors[file] = {} end
	table.insert(processors[file], { scriptname = scriptname, f = func })
end

load_script_files {
	add_processor = function (file, func) add_processor_raw(name, file, func) end,
	add_printer = function () end,
	add_choice_text_conditional = function () end,
	add_choice_text = function () end,
	add_choice_itemtext = function () end,
	add_choice_function = function () end,
	add_interceptor = function () end,
	add_automator = function () end,
}

if requestpath == "/adventure.php" then
	local z = tonumber(requestquery:match("snarfblat=([0-9]+)"))
-- 	print("setting zone", zone)
	if z then
		fight["zone"] = z
		session["adventure.lastzone"] = z
	end
end

setup_variables()
-- setup_functions()

-- if requestpath == "/adventure.php" and zone then
-- 	local encounter = nil
-- 	if monster_name then
-- 		encounter = monster_name
-- 	elseif adventure_result then
-- 		encounter = adventure_result
-- 	else
-- 		encounter = adventure_title
-- 	end
-- 	print("adventure in zone", zone, "got me", encounter, "   $$$$  %%% ", monster_name, adventure_title, adventure_result)
-- 	local tbl = get_ascension_state("zone-"..zone.."-encounters")
-- 	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
-- 	table.insert(tbl, encounter)
-- 	set_ascension_state("zone-"..zone.."-encounters", table_to_str(tbl))
-- end

do
	local semis = get_semirare_encounters()
	local function matches(x)
		if monster_name and new_fight_started then
			return monster_name:contains(x)
		elseif adventure_title == x or adventure_result == x then
			return true
		elseif text:contains(">There once was a bleary-eyed cyclops<") and x == "The Bleary-Eyed Cyclops" then -- HACK! The page for the cyclops eyedrops is weird
			return true
		else
			return false
		end
	end
	for x in table.values(semis) do
		if matches(x) then
			print("SEMIRARE!!!", x)
			set_ascension_state("fortune cookie numbers", "")
			set_ascension_state("last semirare encounter", x)
			set_ascension_state("last semirare turn", turnsthisrun())
		end
	end
end

run_functions(path, text, function (target, pt)
-- 	print("running processors for", target)
	for _, x in ipairs(processors[target] or {}) do
		getfenv(x.f).text = pt
		x.f()
	end
	return pt
end)

-- print(text)

return text

end

function loadfile_with_env(scriptname, env)
-- 	print("loadfile", scriptname)
	local f, e = loadfile("scripts/" .. scriptname)
	if not f then error(e, 2) end
	setfenv(f, env)
	f()
end

local g_store = {}
local g_env = {}
local f_store = {}
g_env._G = g_env
local store_target = g_store
local store_target_name = "g_store"

local logged = {}
local function logprint(k, msg)
	local x = tostring(k)..":"..msg
	if not logged[x] then
		print(k, msg)
		logged[x] = true
	end
end

setmetatable(g_env, { __index = function(t, k)
	local g_v = rawget(g_store, k)
	if g_v ~= nil then
-- 		logprint(k, "from g_v")
		return g_v
	end

	local f_v = rawget(f_store, k)
	if f_v ~= nil then
-- 		logprint(k, "from f_v")
		return f_v
	end

-- 	logprint(k, "from _G")
	return _G[k]
end, __newindex = function(t, k, v)
-- 	if store_target_name ~= "g_store" then
-- 		print("process", store_target_name, "set", k, "=", "...")
-- 	end
	store_target[k] = v
end	})
setfenv(wrapped_function, g_env)

function dofile(f)
	loadfile_with_env("../" .. f, g_env)
end

loadfile_with_env("base/util.lua", g_env)

input_params = raw_input_params
params = g_env.parse_params(raw_input_params)

g_env.setup_functions()

for x in table.values { "path", "query", "requestpath", "requestquery", "text", "input_params", "params" } do
	f_store[x] = _G[x]
	_G[x] = nil
end

store_target = f_store
store_target_name = "f_store"

return wrapped_function()
